<!--
     Copyright 2021, Data61, CSIRO (ABN 41 687 119 230)

     SPDX-License-Identifier: CC-BY-SA-4.0
-->

# Proof Engineering Plans/Ideas

This repository lists ideas, problems, and projects related to l4v proof
engineering. Its primary focus is on strategic engineering goals.

These are mostly ideas, not thought-out projects or well-defined tasks. If you
are inspired by one of these ideas and want to implement it, discuss it with the
@verification team on GitHub or discuss more widely on [Discourse][] to refine the
idea into something that can become a [Jira][] task or project before you start
working on it. If it is already well-defined or an existing Jira issue, feel
free to ask for it to be assigned to you so that people know someone is working
on it. If you don't know who to contact, email [Gerwin Klein][].

[Discourse]: https://sel4.discourse.group
[Jira]: https://sel4.atlassian.net/
[Gerwin Klein]: https://doclsf.de/

## Overview

The main files in this repository are:

- [The Matrix][matrix]: This describes the next large project that we want to
work on when we have time.

- [Smaller Tasks][smaller_tasks]: This contains a list of smaller tasks. Good for
background work or something to improve in between larger projects.

- [Other Ideas][other_ideas]: Anything else

[smaller_tasks]: smaller_tasks.md
[matrix]: the-matrix.md
[other_ideas]: other_ideas.md
